// RegistryManip.h: interface for the CRegistryManip class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGISTRYMANIP_H__8A22C47A_5A40_4FA1_A47A_0A1DB3861D99__INCLUDED_)
#define AFX_REGISTRYMANIP_H__8A22C47A_5A40_4FA1_A47A_0A1DB3861D99__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////
//

const CString c_strStringIdReg		(_T("StringID"));
const CString c_strFlagReg			(_T("Flag"));
const CString c_strSepReg			(_T(";"));


/////////////////////////////////////////////////////////////////



class CRegistryManip  
{
public:

	CRegistryManip();
	virtual ~CRegistryManip();

///////////////

	// vyzyvaet RegOpenKeyEx, RegQueryValueEx, RegCloseKey
	BOOL getInfoFromRegistry(const HKEY hKey, const TCHAR* pSubKey, 
		 					 const TCHAR* pRegKey, TCHAR *pRes, 
							 DWORD dwType = REG_SZ);


	// ishhet Subkeys (podkljuchi) v registry: RegEnumValue, RegQueryMultipleValues
	void FindAllParamsWithValues(HKEY hKeyBase, const CString& csKeyPath, 
								 CStringArray& acsKeyList, CStringArray& acsValList);

	// vyzyvaet RegCreateKeyEx
	BOOL CreateNewKey(const HKEY hKeyBase, const TCHAR* pKeyPath, const TCHAR* pNewKey);

	// vyzyvaet RegSetValueEx
	BOOL InputNewValue(const HKEY hKeyBase, const TCHAR* pKeyPath, const TCHAR* pKeyName, 
					   int nVal, BOOL& bIsInReg, DWORD dwType = REG_SZ);

	// menjaem znachenie parametra
	BOOL ChangeOneVal(const HKEY hKey, const TCHAR* pSubKey, const TCHAR* pRegKeyMain, 
					  const TCHAR* pRegKeyToChange, int nValMain, int nValPaar, 
					  BOOL& bWasFound);

	// poluchaem imenja vseh Subkeys (podkljuchej), nahodjashhihsja vo vseh vlozhennyh papkah
	BOOL GetNamesOfAllSubKeys(HKEY hKeyBase, const CString& csKeyPath, CStringArray& acsKeyList);

	// udaljaem kljuch ili parametr
	BOOL DeleteInfoFromRegistry(const HKEY hKey, const char* pSubKey, const TCHAR* pKeyName);

	void ParseKeysAndValuesStr(const CStringArray& acsKeyList, const CStringArray& acsValList,
							   CStringArray& acsStringIdVal, CStringArray& acsFlagVal,
							   const CString& cstrName1, const CString& cstrName2);

	BOOL GetCountOfSubKeysAll(const HKEY hKey, const TCHAR* pSubKey, unsigned long& nSubKeysCount);


private:

	// vyzyvaet RegOpenKeyEx
	BOOL OpenRegKey(const HKEY hKey, const TCHAR* pSubKey, HKEY& hKeyPrograms, 
					REGSAM samDesired = KEY_READ);

	// vyzyvaet RegCloseKey
	BOOL CloseRegKey(HKEY hKey);

	// vyzyvaet RegQueryValueEx
	BOOL GetOneValueFromReg(HKEY hKey, const TCHAR* pRegKey, TCHAR *pRes, 
							DWORD dwType = REG_SZ);

	// vyzyvaet RegSetValueEx
	BOOL SetOneValue(HKEY hKey, const TCHAR* pKeyName, const TCHAR* pKeyVal, 
					 DWORD dwType = REG_SZ);

	// vyzyvaet RegQueryInfoKey
	BOOL GetCountOfSubKeys(HKEY hKey, unsigned long& nSubKeysCount);

	// vyzyvaet RegEnumKey: 
	// VAZHNO!!! Rabotaet tol'ko v tom sluchae, esli osnovnaja papka imeet vlozhennye papki - 
	// v jetom sluchae mozhno schitat' imena vseh podkljuchej, nahodjashhihsja vo vlozhennyh 
	// papkah.Esli zhe v papke soderzhatsja tol'ko parametry i ih znachenija, to spisok jetih 
	// parametrrov udastsja poluchit' tol'ko s pomoshh'ju funkcii RegEnumValue
	BOOL GetNameOfCurSubKey(HKEY hKey, int nIndex, TCHAR *pNameRes);

	void ParseOneStr(CStringArray& acsStringVal, const CString& cstrVal, 
					 const CString& cstrKeyName, BOOL bStandSep = TRUE, 
					 TCHAR* pStrCurSep = NULL);

	BOOL SeekCurStringInReg(const CString& cstrBaseVal, const CString& cstrCurVal, 
							const CString& cstrKeyName);

	// proverjaem, est' li dannaja papka v registry
	BOOL CheckIfKeyExists(const HKEY hKey, const TCHAR* pSubKey);

	// udaljaem SubKey 
	BOOL DeleteSubKeyFromRegistry(const HKEY hKey, const char* pSubKey);

	// udaljaem parametr
	BOOL DeleteParamFromRegistry(const HKEY hKey, const char* pSubKey, const TCHAR* pKeyName);


///////

private:

	TCHAR	m_cstrValSep[10];
};

#endif // !defined(AFX_REGISTRYMANIP_H__8A22C47A_5A40_4FA1_A47A_0A1DB3861D99__INCLUDED_)
